###############
#Fonctions utilitaires
#################
def AlphaNum(ch):
    num=[]
    for car in ch:
        num.append(ord(car)-65)
    return num



def NumAlpha(liste):
    ch=""
    for n in liste:
        ch=ch+(chr(n+65))
    return ch



##################
#Fonctions techniques
##################

def Affine(liste,a,b):
    res=[]
    for i in liste:
        j=i
        if (0<=i) and (i<=25):
            j=(a*i+b)%26
        res.append(j)
    return res



def Inverse26(n):
    inv=0
    for i in range(26):
        m=n*i%26
        if m==1:
            inv=i
    return inv



def CleDechiffre(a,b):
    c=Inverse26(a)
    if c==0:
        d=0
    else:
        d=(-c*b)%26
    return [c,d]



def BruteForce(liste):
    for k in [1,3,5,7,9,11,15,17,19,21,25]:
        for l in range(26):
            print(NumAlpha(Affine(liste,k,l)))



def Espion(carclair1,carchiffre1,carclair2,carchiffre2,):
    nclair1=ord(carclair1)-65
    nchiffre1=ord(carchiffre1)-65
    nclair2=ord(carclair2)-65
    nchiffre2=ord(carchiffre2)-65
    i=(nclair1-nclair2)%26
    j=Inverse26(i)
    a=((nchiffre1-nchiffre2)*j)%26
    b=(nchiffre1-a*nclair1)%26
    [c,d]=CleDechiffre(a,b)
    return [c,d]




###################
#Procédures de Chiffrement/Déchiffrement/Décryptage
###################

def Chiffrer():
    messclair=input("Entrez votre message clair en majuscules et sans accents : ")
    messnum=AlphaNum(messclair)
    a=int(input("Choisissez la valeur de a : "))
    b=int(input("Choisissez la valeur de b : "))
    crypto=Affine(messnum,a,b)
    messcrypt=NumAlpha(crypto)
    print("Le message chiffré est : ",messcrypt)





def Dechiffrer():
    a=int(input("Entrez la valeur de a : "))
    b=int(input("Entrez la valeur de b : "))
    [c,d]=CleDechiffre(a,b)
    print("La clé de déchiffrement associée à la clé de chiffrement ",[a,b]," est ",[c,d])
    #input()
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    decrypto=Affine(cryptonum,c,d)
    mess=NumAlpha(decrypto)
    print("Le message clair est : ",mess)





def DecrypterEspion():
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    print("Vous pensez que la lettre L1 est chiffrée par la lettre M1 et que la lettre L2 est chiffrée par la lettre M2 ?")
    car1=input("Entrez L1 : ")
    car2=input("Entrez M1 : ")
    car3=input("Entrez L2 : ")
    car4=input("Entrez M2 : ")
    [c,d]=Espion(car1,car2,car3,car4)
    decrypto=Affine(cryptonum,c,d)
    mess=NumAlpha(decrypto)
    print("Si vous avez raison, et si les lettres devinées permettent le calcul, le message clair est : ",mess)






def DecrypterBrute():
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    print("Le message clair correspondant est dans la liste ci-dessous : ")
    BruteForce(cryptonum)
                 

